# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4
from turbogears import controllers, expose, flash, redirect
from model import *
from json import *
import cherrypy
import backup

# import logging
# log = logging.getLogger("oxdbarchive.controllers")

'''
/sha1/frame/position.jpg
/sha1/clip/position.jpg
/sha1/metadata
'''

def httpExpires(sec):
    exp_date = cherrypy.lib.httptools.HTTPDate(time.gmtime(time.mktime(time.gmtime()) + sec))
    return exp_date

class Root(controllers.RootController):
    @expose()
    def default(self, sha1Hash = None, action = None, position = None):
        if not sha1Hash:
            return dict()
        try:
            f = ArchiveFile.bySha1sum(sha1Hash)
        except:
            #return dict()
            f = backup.Backup(sha1Hash)
            if not f.exists():
                return dict()
        if action == 'metadata':
            return dict(metadata = f)
        elif action in ('timeline', 'timeline.png'):
            cherrypy.response.headerMap['Content-Type'] = "image/png"
            cherrypy.response.headerMap["Expires"] = httpExpires(60*60*24*15)
            return f.timeline()
        elif position: #clip / frame
            position = position.replace('.png', '').replace('.jpg', '')
            position = position.replace('.flv', '').replace('.ogv', '')
            position = position.replace('-', ':').replace('.',':')
            cherrypy.response.headerMap["Expires"] = httpExpires(60*60*24*15)
            if action == 'clip':
                cherrypy.response.headerMap['Content-Type'] = "video/x-flv"
                return f.flvClip(position)
            if action == 'ogv':
                cherrypy.response.headerMap['Content-Type'] = "video/ogg"
                return f.oggClip(position)
            elif action == 'frame':
                cherrypy.response.headerMap['Content-Type'] = "image/jpeg"
                return f.frame(position)
            elif action == 'still':
                cherrypy.response.headerMap['Content-Type'] = "image/png"
                return f.still(position)
            elif action == 'posterStill':
                cherrypy.response.headerMap['Content-Type'] = "image/png"
                return f.posterStill(position)
        return dict()

